﻿# Create users and Groups for Lab
# Bohack
# 08/31/14

Import-Module ActiveDirectory

# Create the OU structure 

Echo "Creating OU Structure"
New-ADOrganizationalUnit -Name Contoso -Path "DC=Contoso,DC=Com"
New-ADOrganizationalUnit -Name Users -Path "OU=Contoso,DC=Contoso,DC=Com"
New-ADOrganizationalUnit -Name Groups -Path "OU=Contoso,DC=Contoso,DC=Com"
New-ADOrganizationalUnit -Name Servers -Path "OU=Contoso,DC=Contoso,DC=Com"

# Create the groups

Echo "Creating Groups"
New-ADGroup -Name "IT Department" -SamAccountName ITDept -GroupScope DomainLocal -Path “OU=Groups,OU=Contoso,DC=Contoso,DC=Com”
New-ADGroup -Name "Sales" -SamAccountName Sales -GroupScope DomainLocal -Path “OU=Groups,OU=Contoso,DC=Contoso,DC=Com”
New-ADGroup -Name "Marketing" -SamAccountName Marketing -GroupScope DomainLocal -Path “OU=Groups,OU=Contoso,DC=Contoso,DC=Com”
New-ADGroup -Name "Research" -SamAccountName Research -GroupScope DomainLocal -Path “OU=Groups,OU=Contoso,DC=Contoso,DC=Com”

Function CreateUsers {
    Param
    ([string]$FirstName,[string]$LastName,[string]$Department,[string]$Group)
    Echo "Creating User $Firstname $Lastname"
    New-ADUser -Name "$Firstname, $Lastname" -AccountPassword (ConvertTo-SecureString “Password20!” -AsPlainText -Force) -ChangePasswordAtLogon $false -Company “Contoso” -DisplayName “$Lastname, $Firstname” -Enabled $true -SamAccountName $Firstname$Lastname -Path “OU=Users,OU=Contoso,DC=Contoso,DC=Com” -Givenname $Firstname -Surname $Lastname -userprincipalname (“$Firstname$Lastname” + “@contoso.com”) -department "$Department”    -description "$Firstname $Lastname”
    Add-ADGroupMember -Identity $Group -Member $Firstname$Lastname
    }

# Create the users

CreateUsers -FirstName Tech -LastName One -Department IT -Group ITDept
CreateUsers -FirstName Tech -LastName Two -Department IT -Group ITDept
CreateUsers -FirstName Tech -LastName Three -Department IT -Group ITDept
CreateUsers -FirstName Tech -LastName Four -Department Research -Group ITDept
CreateUsers -FirstName Sales -LastName One -Department IT -Group Sales
CreateUsers -FirstName Sales -LastName Two -Department Sales -Group Sales
CreateUsers -FirstName Sales -LastName Three -Department Sales -Group Sales
CreateUsers -FirstName Marketing -LastName One -Department Marketing -Group Marketing
CreateUsers -FirstName Marketing -LastName Two -Department Marketing -Group Marketing
CreateUsers -FirstName Marketing -LastName Three -Department Marketing -Group Marketing
CreateUsers -FirstName Research -LastName One -Department IT -Group Research
CreateUsers -FirstName Research -LastName Two -Department Research -Group Research
CreateUsers -FirstName Research -LastName Three -Department Research -Group Research

# Add the users to collateral groups

Echo "Adding Users to collateral groups"
Add-ADGroupMember -Identity Research -Member techfour
Add-ADGroupMember -Identity Sales -Member techone 
Add-ADGroupMember -Identity ITDept -Member researchone 

